/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================
Program:   bbtk
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and
*  abiding by the rules of distribution of free software. You can  use,
*  modify and/ or redistribute the software under the terms of the CeCILL-B
*  license as circulated by CEA, CNRS and INRIA at the following URL
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability.
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */

/**
*  \file
*  \brief Class bbtk::GPortController
*/


#include "GPortController.h"

namespace bbtk
{


	//=========================================================================
	GPortController::GPortController()
	{
		_isLeftClickDown=false;
	}

	//=========================================================================
	GPortController::~GPortController()
	{
	}
	//=========================================================================

	bool GPortController::OnLeftButtonDown()
	{

		int state  = _view->getState();

		//Evaluate new state
		if(state == HIGHLIGHTED)
		{
			_isLeftClickDown=true;
		}
		return true;
	}
	//=========================================================================
	bool GPortController::OnLeftButtonUp()
	{
		int state  = _view->getState();
		if(_isLeftClickDown)
		{
			if(state==HIGHLIGHTED)
			{
				int portType = ((GPortModel*)_model)->getPortType();

				//Evaluate new state
				if(portType==GOUTPUTPORT)
				{
					_model->notifyObservers(getId(),INIT_CREATION_CONTOUR);
				}
				else if (portType==GINPUTPORT)
				{
					_model->notifyObservers(getId(),FIN_CREATION_CONTOUR);
				}
			}
			else
			{
				_view->setState(NOTHING_HAPPENS);
			}
			_isLeftClickDown=false;
		}

		return true;
	}

	//=========================================================================



}  // EO namespace bbtk

// EOF

